import { RouteReuseStrategy, ActivatedRouteSnapshot, DetachedRouteHandle } from "@angular/router";
import { NSLocationStrategy } from "./ns-location-strategy";
/**
 * Does not detach any subtrees. Reuses routes as long as their route config is the same.
 */
export declare class NSRouteReuseStrategy implements RouteReuseStrategy {
    private location;
    private cache;
    constructor(location: NSLocationStrategy);
    shouldDetach(route: ActivatedRouteSnapshot): boolean;
    shouldAttach(route: ActivatedRouteSnapshot): boolean;
    store(route: ActivatedRouteSnapshot, state: DetachedRouteHandle): void;
    retrieve(route: ActivatedRouteSnapshot): DetachedRouteHandle | null;
    shouldReuseRoute(future: ActivatedRouteSnapshot, curr: ActivatedRouteSnapshot): boolean;
    clearCache(): void;
}
